package examen.horloge;

import java.time.LocalTime;
import java.util.ArrayList;

/**
 * <p>Horloge class.</p>
 *
 * @author db200253
 * @version $Id: $Id
 */
public class Horloge extends Thread {
  private Heure heure;
  
  public ArrayList<EcouteurHorloge> liste = new ArrayList<EcouteurHorloge>();
  
  public void ajouterEcouteur(EcouteurHorloge eh) {
    
    liste.add(eh);
  }
  
  public void SuppEcouteur(EcouteurHorloge eh) {
    
    liste.remove(eh);
  }

  /**
   * <p>run.</p>
   */
  public void run() {
    while (true) {
      LocalTime heureJava = LocalTime.now();
      adaptationHeure(heureJava);
      try {
        Thread.sleep(100);
      } catch (InterruptedException e) {
        System.err.println("pause interrompue");
      }
    }
  }

  private void adaptationHeure(LocalTime heureJava) {
    Heure heureActuelle = new Heure(heureJava);
    if (!heureActuelle.equals(heure)) {
      heure = heureActuelle;
      
      for(EcouteurHorloge  elt : liste) {
        
        elt.heureModifiee(heure);
      }
    }
  }

  /**
   * <p>Getter for the field <code>heure</code>.</p>
   *
   * @return a {@link examen.horloge.Heure} object
   */
  public Heure getHeure() {
    return heure;
  }
}
